# LiveCore 2.0 -> 3.0 changeLog

## maven仓库更改

原仓库地址

```
maven { url 'http://git.baijiashilian.com/open-android/maven/raw/master/' }
```

更改为

```
maven { url 'https://git2.baijiashilian.com/open-android/maven/raw/master/' }
```

##  删除废弃API
### 1、LiveSDK

删除enterRoom()超长形参函数，替换为下面两种方式：
 
#### 参加码进房间

```
LiveRoom enterRoom(@NonNull final Context context, LPJoinCodeEnterRoomModel joinCodeEnterRoomModel, LPLaunchListener launchListener)
```
LPJoinCodeEnterRoomModel 包含参加码进房间的所有信息，提供两个常用构造函数，其余字段可以按需赋值。

```
    public LPJoinCodeEnterRoomModel(String joinCode, String userName) {
    }

    public LPJoinCodeEnterRoomModel(String joinCode, String userName, String userAvatar, LPConstants.LPUserType userType) {
    }
```

#### 签名进房间

```
LiveRoom enterRoom(@NonNull final Context context, LPSignEnterRoomModel signEnterRoomModel, LPLaunchListener launchListener)
```
LPSignEnterRoomModel 包含签名进房间的所有信息，提供常用构造函数，其余字段可以按需赋值。

```
 public LPSignEnterRoomModel(long roomId, IUserModel userModel, String sign) {
        this.roomId = roomId;
        this.userName = userModel.getName();
        this.userNumber = userModel.getNumber();
        this.userAvatar = userModel.getAvatar();
        this.userType = userModel.getType();
        this.groupId = userModel.getGroup();
        this.sign = sign;
    }
```

### 2、LiveRoom

1、 删除 getGroupId()

```
    /**
     * 获得GroupId
     */
    int getGroupId();
```  
替换为

```
    IUserModel userModel = liveRoom.getCurrentUser();
    userModel.getGroup();
```

2、删除 getAutoStartCloudRecordStatus()

```
    /**
     * 获取是否支持默认开启云端录制
     */
    int getAutoStartCloudRecordStatus();

```
3、删除 getSurveyVM()

4、删除 sendGift()、getObservableOfGift()、requestFreeCall()、setOnRollCallListener()

5、删除 Observable<String> getObservableOfUserOut()、Observable<IUserModel> getObservableOfUserOutWithUserModel()

替换为

```
liveRoom.getOnlineUserVM(). getObservableOfUserOut()
```

6、删除 getObservableOfUserNumberChange()

替换为

```
liveRoom.getOnlineUserVM().getObservableOfOnLineUserCount()
```

7、删除 getCurrentUserCount()

替换为

```
liveRoom.getOnlineUserVM().getUserCount()
```

8、删除 Observable<String> getObsrvableOfKickOut()、Observable<LPError> getObservableOfKickOutWithError()

替换为

```
Observable<LPError> getObservableOfKickOut()
```

9、删除  Observable<LPCloudRecordModel.LPRecordValueModel> getObservableOfCloudRecordStatus2()、    Observable<Boolean> getObservableOfCloudRecordStatus()

替换为

```
Observable<LPCloudRecordModel.LPRecordValueModel> getObservableOfCloudRecordStatus()
```

10、删除 LPError requestCloudRecord(boolean isCloudRecordOn)

请使用

```
 LPError requestCloudRecord(LPConstants.CloudRecordStatus cloudRecordStatus)
```

11、删除  boolean getCloudRecordStatus()、    LPCloudRecordModel.LPRecordValueModel getCloudRecordStatus2()

替换为

```
LPCloudRecordModel.LPRecordValueModel getCloudRecordStatus();
```

12、删除 Observable<Integer> getObservableOfReconnected()， 2.x SDK 内部没有回调出来

13、删除 String getCustomerSupportDefaultExceptionMessage()

14、删除 void sendSpeakInvite(int confirm)

替换为

```
liveRoom.getSpeakVM().sendSpeakInvite(int confirm);
```
15、删除 void sendSpeakInviteReq(String userId, boolean invite)

替换为

```
liveRoom.getSpeakVM().sendSpeakInviteReq(String userId,boolean invite);
```

16、boolean getIsDefaultWhiteBoard() 重命名为 boolean isDefaultWhiteBoard()

17、删除  Observable<Boolean> getObservableOfQuestionForbidStatus()

替换为

```
liveRoom.getToolBoxVM().getObservableOfQuestionForbidStatus();
```

18、移除双师相关API （不再对外暴露）

19、删除  void requestPlayerViewUpdate(LPPlayerViewUpdateModel popupLivePlayerPosition)

替换为

```
liveRoom.getMediaVM(). requestPlayerViewUpdate(LPPlayerViewUpdateModel popupLivePlayerPosition)
```

20、删除 Observable<LPPlayerViewUpdateModel> getObservableOfPlayerViewUpdate()

替换为

```
liveRoom.getMediaVM(). getObservableOfPlayerViewUpdate()
```

21、 删除 LPPlayerViewUpdateModel getPlayerViewUpdate()

替换为

```
liveRoom.getMediaVM(). getPlayerViewUpdate()
```
22、删除 loadMoreQuestions()

替换为

```
liveRoom.getToolBoxVM().requestQuestionPullReq()
```

23、删除 sendQuestion()

替换为

```
liveRoom.getToolBoxVM().requestQuestionSend()
```

24、删除 Observable<List<LPQuestionPullResItem>> getObservableOfQuestionQueue()

替换为

```
liveRoom.getToolBoxVM().getObservableOfQuestionSendRes()
liveRoom.getToolBoxVM().getObservableOfQuestionPub()
liveRoom.getToolBoxVM().getObservableOfQuestionPullRes()
```

25、删除  Observable<LPQuestionPubModel> getObservableOfQuestionPublish()

替换为

```
liveRoom.getToolBoxVM().getObservableOfQuestionPub()
```

26、删除 isHasMoreQuestion()

27、删除 void requestQuestionPub(LPQuestionPubTriggerModel lpQuestionPubTriggerModel)

替换为

```
liveRoom.getToolBoxVM().requestQuestionPub()
```

28、删除 String getWebRTCToken()

29、删除 Observable<LPPresenterLossRateModel> getObservableOfLPPresenterLossRate()

30、删除 boolean isMixModeOn()

替换为

```
liveRoom.getSpeakVM().isMixModeOn()
```

31、删除 isProEnvironment()

32、删除 isWWWEnvironment()

33、isOrgUser() 替换为 isOrganizationUser()

34、删除 String getSmallClassUserPosition()

35、getMediaViewModel() 重命名为  getMediaVM()

36、删除 setPPTDefinition(boolean isOriginal)、boolean isPPTDefinitionOriginal()

37、删除 boolean disableOtherStudentVideo()

38、删除 Observable<Boolean> getObservableOfDisableOtherStudentVideo()

39、Observable<LPDisableOtherStuVideoModel> getObservableOfDisableOtherStudentVideoData() 重命名为     Observable<LPDisableOtherStuVideoModel> getObservableOfDisableOtherStudentVideo()



















