# LiveCore 3.0 -> 4.0 changeLog

## 1. 删除 AVSDK 和 百家云底层

> 升级到 4.0 SDK 前请务必联系客户经理确认当前使用的音视频底层类型，AVSDK 和 百家云底层因年久失修不再在 4.0 SDK 上支持，包体积能显著降低十余兆，代码逻辑也更清晰。

4.0.0-alpha 版本为非正式版本，带 alpha 或者 beta 代表 API 不保证不继续发生更改，对接core sdk 请谨慎升级。

### 1.1. import 变更

遇到 import 报错，请先删除飘红的 import，再尝试按 IDE 提示自动 import。

```java
com.baijiayun.livecore.context.LPConstants -> com.baijiayun.livebase.context.LPConstants
```

### 1.2. LaunchListener

LaunchListener -> LPRoomStatusListener，合并了原本的 `setRoomStatusListener(LPRoomStatusListener lpRoomStatusListener);` 和直播间出错回调 `void setOnLiveRoomListener(OnLiveRoomListener listener)`。

```java
public interface LPRoomStatusListener {
    /**
     * 进房间进度回调，step/totalStep 即进教室百分比
     * @param step 当前步骤
     * @param totalStep 总步骤数
     */
    void onLaunchSteps(int step, int totalStep);

    /**
     * 进房间出错回调
     * @param error
     */
    void onLaunchError(LPError error);

    /**
     * 进房间成功回调
     * @param liveRoom
     */
    void onLaunchSuccess(LiveRoom liveRoom);

    /**
     * 直播过程中的错误回调
     *
     * @param error
     */
    void onLivingError(LPError error);

    /**
     * 退出房间回调
     */
    void onQuitRoom();
}
```

## 2. LiveSDK 变更清单

### 2.1. 删除的 API

```java
private static LPConstants.VoiceType voiceType;

public static boolean USE_IJK_PULL_STREAM;



public static String DeviceUnique = "";



public static void setDeviceUnique(String deviceUnique) {

DeviceUnique = deviceUnique;

}



public static String getDeviceUnique() {

return DeviceUnique;

}



public static void setAudioOutput(LPConstants.VoiceType lpVoiceType) {

voiceType = lpVoiceType;

}




public static LPConstants.VoiceType getAudioOutput() {

if (voiceType == null) {

voiceType = LPConstants.VoiceType.VOICE_CALL;

}

return voiceType;

}
```

### ## 3. LPRecorder 变更清单

### 3.1 删除的 API

```javaag-0-1hatnfk1tag-1-1hatnfk1u
删除 void stopPublishing(boolean keepAlive); keep_alive 逻辑改为由 core sdk 内部维护

删除 AVSDK 相关 API

1. Flowable<LPConstants.LPResolutionType> getObservableOfVideoDefinition();

2. Flowable<LPConstants.VolumeLevel> getObservableOfVolume();

3. LPMediaResolutionModel getResolution();

4. PublishSubject getMediaControlModelPublishSubject();

5. boolean setLinkType(LPConstants.LPLinkType linkType);

6. boolean setTcpWithCdn(String tag);

7. LPConstants.LPLinkType getLinkType();

8. Flowable<LPConstants.LPLinkType> getObservableOfLinkType();

9. Observable<byte[]> getObservableOfAudioData();

10. void setAudioPcmEnable(boolean enable);

11. void openBeautyFilter();

12. void closeBeautyFilter();

13. boolean isBeautyFilterOn();

14. Flowable getObservableOfBeautyFilterChange();

15. void invalidVideo();

16. void openFlashLight();

17. void closeFlashLight();

18. void switchUDPLink(String ip, int port);

19. int getStreamId();

20. String getStreamName();

21. String getPublishSession();

22. int getPublishIndex();

23. LPIpAddress getUpLinkServer();
```

### 3.2 替换的 API

```java
<T extends View> T getPreview(); 简化为 LPCameraView getPreview();

void takeVideoScreenshot(String uid); 简化为 void takeVideoScreenshot();
```

## 4. LPPlayer 变更清单

### 4.1. 删除的 API

```java
1. LPConstants.LPLinkType getLinkType();

2. boolean setLinkType(LPConstants.LPLinkType linkType);

3. boolean setLinkTypeTcpWithCdn(String preferredCdn);

4. Flowable<LPConstants.LPLinkType> getObservableOfLinkType();

5. Flowable<LPConstants.LPLinkType> getObservableOfPresenterUpStreamLinkType();

6. void setPlayTcpWitIjk(boolean useIjk);

7. Map<Object, Object> getStreamInfo(int streamId);

8. void enableSpeakerPhone(boolean enable);

9. boolean switchUdpDownLinkServer();

10. void playVideo(String mediaId, LPVideoView videoView, LPConstants.VideoDefinition definition);

11. void changeVideoDefinition(String userId, LPConstants.VideoDefinition definition);

12. LPConstants.VideoDefinition getVideoDefinition(String uid);
```

## 5. LiveRoom 变更清单

### 5.1. 删除的 API

```java
1. String getAVLogFilePath();

2. boolean isUseWebRTC();

3. void setOnWebrtcStreamStats(int time, OnWebrtcStreamStatsListener listener);

4. Observable<IUserInModel> getObservableOfUserIn(); 请使用 liveRoom.getOnlineUserVM().getObservableOfUserIn()

5. 删除 Observable<LPResRoomDebugModel> getObservableOfDebug();

6. boolean enablePullAudioOnly();

7. Observable<Boolean> getObservableOfShareDesktop();

8. Observable<LPSpeakInviteModel> getObservableOfSpeakInvite(); 请使用 liveRoom.getSpeakQueueVM().getObservableOfSpeakInvite()

9. Observable<LPSpeakInviteConfirmModel> getObservableOfSpeakInviteRes(); 请使用 liveRoom.getSpeakQueueVM().getObservableOfSpeakInviteRes()

10. Observable<LPUserModel> getObservableOfUserUpdate(); 请使用 liveRoom.getOnlineUserVM().getObservableOfUserUpdate()

11. 删除 void sendPresenterUplinkLossRate(LPPresenterLossRateModel presenterLossRateModel);

12. LPError forbidChat(IUserModel forbidUser, long duration); 请使用 liveRoom.getChatVM().forbidChat(IUserModel forbidUser, long duration);

13. Observable<IForbidChatModel> getObservableOfForbidChat(); 请使用 liveRoom.getChatVM().getObservableOfForbidChat();

14. Observable<LPRoomForbidChatResult> getObservableOfForbidAllChatStatus(); 请使用 liveRoom.getChatVM().getObservableOfForbidAllChatStatus();

15. void requestForbidAllChat(boolean forbidAllChat); 请使用 liveRoom.getChatVM().requestForbidAllChat(boolean forbidAllChat);

16. boolean getForbidStatus(LPConstants.LPForbidChatType type); 请使用 liveRoom.getChatVM().getForbidStatus(LPConstants.LPForbidChatType type);

17. Observable<Boolean> getObservableOfIsSelfChatForbid(); 请使用 liveRoom.getChatVM().getObservableOfIsSelfChatForbid()

18. Observable<LPResRoomForbidListModel> getObservableOfForbidList(); 请使用 liveRoom.getChatVM().getObservableOfForbidList()

19. requestForbidList(); 请使用 liveRoom.getChatVM().requestForbidList();

20. boolean getForbidAllChatStatus(); 请使用 liveRoom.getChatVM().getForbidAllChatStatus();

21. Observable<Boolean> getObservableOfPlayMedia();

22. Observable<LPResRoomBlockedUserModel> getObservableOfBlockedUser(); 请使用 liveRoom.getOnlineUserVM().getObservableOfBlockedUser();

23. Observable<LPError> getObservableOfKickOut(); 请使用 liveRoom.getOnlineUserVM().getObservableOfKickOut();

24. void requestKickOutUser(String userId); 请使用 liveRoom.getOnlineUserVM().requestKickOutUser(String userId);

25. void requestKickOutUser(String userId, boolean isBlock); 请使用 liveRoom.getOnlineUserVM().requestKickOutUser(String userId, boolean isBlock);

26. Observable<LPDocViewUpdateModel> getObservableOfDocViewUpdate(); 请使用 liveRoom.getDocListVM().getObservableOfDocViewUpdate()

27. String getRoomTitle(); 请使用 liveRoom.getRoomInfo().title

28. long getRoomId() 请使用 liveRoom.getRoomInfo().roomId

29. LPConstants.LPRoomType getRoomType() 请使用 liveRoom.getRoomInfo().roomType

30. long getRoomStartTime() 请使用 liveRoom.getRoomInfo().startTime

31. long getRoomStartTimeTs() 请使用 liveRoom.getRoomInfo().startTimets

32. boolean isMockLive(); 请使用 liveRoom.getRoomInfo().isMockLive

33. boolean isPushLive(); 请使用 liveRoom.getRoomInfo().isPushLive

34. boolean isLongTerm(); 请使用 liveRoom.getRoomInfo().isLongTerm

35. boolean isGroupClass();

36. boolean isNewGroupClass();
```

## 6. DocListVM 变更清单

### 6.1. 删除的 API

```java
List getStudentExtCameraList();

boolean isEnableChangeScreenShare();

boolean isContainH5PPTDoc();

LPResHomeworkAllModel getHomeworkSearchRstModelList();

LPError addCloudFile(LPCloudFileModel cloudFileModel); 请使用 liveRoom.getCloudFileVM().requestAddCloudFile(LPCloudFileModel)

Observable<Boolean> getObservableOfDocumentImages(String fids, String name, String ext);

boolean isEnableChangeAssistCamera();

Observable<LPDocumentImageModel> getObservableOfDocumentRemark(String fid);
```

## 7. SpeakQueueVM 变更清单

### 7.1. 删除的 API

```java
void controlRemoteSpeak(String userId, boolean isVideoOn, boolean isAudioOn);
```

## 8. LiveShowVM 变更清单

### 8.1. 删除的 API

```java
void controlRemoteSpeak(String userId, boolean isVideoOn, boolean isAudioOn);

Observable<List<LPLiveGiftModel>> getObservableOfSendGift();

Observable<Map<Integer, LPLiveGiftModel>> getObservableOfGiftChange();

Map<Integer, LPLiveGiftModel> getGiftAll();

LPRewardConfigResponse getRewardConfig();
```
