package com.baijiayun.bjhl_liveplayer;

import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.widget.Button;
import android.widget.EditText;
import android.widget.RadioGroup;
import android.widget.Toast;

import androidx.appcompat.app.AppCompatActivity;

import com.baijiayun.livebase.context.LPConstants;


public class JoinLoginActivity extends AppCompatActivity {
    private SharedPreferences sharedPreferences;
    Context context;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_join_login);
        context = this;
        sharedPreferences = PreferenceManager.getDefaultSharedPreferences(this);
        EditText customDomainEt = findViewById(R.id.custom_domain_et);
        EditText joinCodeEt = findViewById(R.id.join_code_et);
        EditText joinNameEt = findViewById(R.id.pw_join_code_et);
        String cusDomain = sharedPreferences.getString(App.CUSTOM_DOMAIN, "");
        String code = sharedPreferences.getString(App.JOIN_CODE, "");
        String name = sharedPreferences.getString(App.USER_NAME, "");
        customDomainEt.setText(cusDomain);
        joinCodeEt.setText(code);
        joinNameEt.setText(name);
        RadioGroup identityRg = findViewById(R.id.login_identity_group);
        final LPConstants.LPUserType[] lpUserType = {LPConstants.LPUserType.Visitor};
        identityRg.setOnCheckedChangeListener((group, checkedId) -> {
            if (checkedId == group.getChildAt(0).getId()) {
                lpUserType[0] = LPConstants.LPUserType.Teacher;
            } else if (checkedId == group.getChildAt(1).getId()) {
                lpUserType[0] = LPConstants.LPUserType.Assistant;
            } else if (checkedId == group.getChildAt(2).getId()) {
                lpUserType[0] = LPConstants.LPUserType.Student;
            }
        });
        Button loginBtn = findViewById(R.id.login_btn);
        loginBtn.setOnClickListener(v -> {
            if (lpUserType[0] == LPConstants.LPUserType.Visitor) {
                Toast.makeText(this, "请选择一个身份", Toast.LENGTH_SHORT).show();
            } else {
                SharedPreferences.Editor editor = sharedPreferences.edit();
                editor.putString(App.CUSTOM_DOMAIN, customDomainEt.getText().toString());
                editor.putString(App.JOIN_CODE, joinCodeEt.getText().toString());
                editor.putString(App.USER_NAME, joinNameEt.getText().toString());
                editor.apply();

                Bundle bundle = new Bundle();
                bundle.putString(App.JOIN_CODE, joinCodeEt.getText().toString());
                bundle.putString(App.USER_NAME, joinNameEt.getText().toString());
                bundle.putString(App.CUSTOM_DOMAIN, customDomainEt.getText().toString());
                bundle.putInt("USER_TYPE", lpUserType[0].getType());
                Intent intent = new Intent(context, MainActivity.class);
                intent.putExtras(bundle);
                startActivity(intent);
            }
        });
    }
}
