package com.baijiayun.bjhl_liveplayer.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.baijiayun.livecore.context.LiveRoom;

import java.util.List;

public abstract class CommonAdapter<VH extends RecyclerView.ViewHolder> extends RecyclerView.Adapter<RecyclerView.ViewHolder> {
    private List<?> userList;
    private final Context context;
    private final int itemId;
    private LiveRoom liveRoom;

    protected CommonAdapter(Context context,int itemId){
        this.context=context;
        this.itemId=itemId;
    }

    @NonNull
    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        View view = LayoutInflater.from(context).inflate(itemId,parent,false);
        return getVH(view);
    }

    @Override
    public int getItemCount() {
        return userList == null ? 0 : userList.size();
    }

    //获取ViewHolder，实现交给继承者
    public abstract VH getVH(View view);

    public void setList(List<?> userList) {
        this.userList = userList;
        notifyDataSetChanged();
    }

    public List<?> getList() {
        return userList;
    }

    public Context getContext() {
        return context;
    }

    public int getItemId() {
        return itemId;
    }

    public LiveRoom getLiveRoom() {
        return liveRoom;
    }

    public void setLiveRoom(LiveRoom liveRoom) {
        this.liveRoom = liveRoom;
    }
}
