package com.baijiayun.bjhl_liveplayer.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;

import androidx.recyclerview.widget.RecyclerView;

import com.baijiayun.bjhl_liveplayer.R;
import com.baijiayun.glide.Glide;
import com.baijiayun.livebase.models.LPExpressionModel;

import java.util.List;

public class ExpressionAdapter extends RecyclerView.Adapter<RecyclerView.ViewHolder> {
    List<LPExpressionModel> datas;
    Context mContext;
    LPExpressionModel expressionModel;
    OnExpressionClickListener onExpressionClickListener;

    public void setOnExpressionClickListener(OnExpressionClickListener onExpressionClickListener) {
        this.onExpressionClickListener = onExpressionClickListener;
    }

    public ExpressionAdapter(Context mContext, List<LPExpressionModel> datas) {
        this.datas = datas;
        this.mContext = mContext;
    }

    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
        View view = LayoutInflater.from(mContext).inflate(R.layout.item_expression,parent,false);
        return new ExpressionViewHolder(view);
    }

    @Override
    public void onBindViewHolder(RecyclerView.ViewHolder holder, int position) {
        expressionModel = datas.get(position);
        ExpressionViewHolder viewHolder = (ExpressionViewHolder) holder;
        Glide.with(mContext)
                .load(expressionModel.getUrl())
                .into(viewHolder.ivExpression);
        viewHolder.expressionModel = expressionModel;
    }

    @Override
    public int getItemCount() {
        if (datas != null && datas.size() > 0) {
            return datas.size();
        }
        return 0;
    }

    public class ExpressionViewHolder extends RecyclerView.ViewHolder {
        private ImageView ivExpression;
        LPExpressionModel expressionModel;
        public ExpressionViewHolder(View itemView) {
            super(itemView);
            ivExpression = itemView.findViewById(R.id.expression_image);
            ivExpression.setOnClickListener(view->{
                onExpressionClickListener.onExpressionClick(expressionModel);
            });
        }
    }

    public interface OnExpressionClickListener{
        void onExpressionClick(LPExpressionModel expressionModel);
    }
}
