package com.baijiayun.bjhl_liveplayer.adapter;

import android.content.Context;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.baijiayun.bjhl_liveplayer.R;
import com.baijiayun.livebase.context.LPConstants;
import com.baijiayun.livebase.models.imodels.IUserModel;
import com.baijiayun.livecore.models.LPQuestionPubTriggerModel;
import com.baijiayun.livecore.models.LPQuestionPullListItem;
import com.baijiayun.livecore.models.LPQuestionPullResItem;

import java.util.List;

public class QaRecyclerCommonAdapter extends CommonAdapter<QaRecyclerCommonAdapter.QaRecyclerCommonViewHolder>{

    public int status;
    private static final String TAG = "ToolBoxActivity";
    private enum OperateStatus{
        PUBLISH(15),PUBLISH_CANCEL(14),REPLY(5);
        int status;
        OperateStatus(int status){
            this.status = status;
        }
        public int getStatus() {
            return status;
        }
    }

    public QaRecyclerCommonAdapter(Context context, int itemId) {
        super(context, itemId);
    }

    @Override
    public QaRecyclerCommonViewHolder getVH(View view) {
        return new QaRecyclerCommonViewHolder(view);
    }

    @Override
    public void onBindViewHolder(@NonNull RecyclerView.ViewHolder holder, int position) {
        IUserModel iUserModel = getLiveRoom().getCurrentUser();
        QaRecyclerCommonViewHolder qaVH = (QaRecyclerCommonViewHolder) holder;
        LPQuestionPullResItem lpQuestionPullResItem = (LPQuestionPullResItem) getList().get(position);
        List<LPQuestionPullListItem> lpQuestionPullListItems = lpQuestionPullResItem.itemList;

        //初始化replyManage
        qaVH.replyManage.removeAllViews();

        if (iUserModel.getType() == LPConstants.LPUserType.Student
            || iUserModel.getType() == LPConstants.LPUserType.Visitor){
            qaVH.qaBtnPublish.setVisibility(View.GONE);
            qaVH.qaBtnReply.setVisibility(View.GONE);
            //如果只是取消发布那就只有老师能做
            qaVH.qaBtnDelete.setVisibility(View.GONE);
        }else {
            //发布、回复、取消发布传参
            LPQuestionPubTriggerModel lpPubTriggerModel = new LPQuestionPubTriggerModel();

            if (status == 1){
                //已发布状态，老师不需要发布按钮:追加回复(回复)和取消发布
                qaVH.qaBtnPublish.setVisibility(View.GONE);
            }else {
                qaVH.qaBtnPublish.setOnClickListener(v -> {
                    lpPubTriggerModel.operate = OperateStatus.PUBLISH.getStatus();
                    lpPubTriggerModel.id = lpQuestionPullResItem.id;
                    lpPubTriggerModel.content = lpQuestionPullListItems.get(0).content;
                    lpPubTriggerModel.from = lpQuestionPullListItems.get(0).from;
                    //发布
                    getLiveRoom().getToolBoxVM().requestQuestionPub(lpPubTriggerModel);
                });
            }

            qaVH.qaBtnDelete.setOnClickListener(v -> {
                //取消发布
                lpPubTriggerModel.id = lpQuestionPullResItem.id;
                lpPubTriggerModel.operate = OperateStatus.PUBLISH_CANCEL.getStatus();
                lpPubTriggerModel.content = lpQuestionPullListItems.get(0).content;
                lpPubTriggerModel.from = lpQuestionPullListItems.get(0).from;
                getLiveRoom().getToolBoxVM().requestQuestionPub(lpPubTriggerModel);
            });

            qaVH.qaBtnReply.setOnClickListener(v -> {
                //回复直接提交，暂不作保存
                lpPubTriggerModel.id = lpQuestionPullResItem.id;
                lpPubTriggerModel.operate = OperateStatus.REPLY.getStatus();
                lpPubTriggerModel.from = lpQuestionPullListItems.get(0).from;
                String content = qaVH.replyEt.getText().toString();
                if ("".equals(content)){
                    Toast.makeText(getContext(),"请输入回复内容",Toast.LENGTH_SHORT).show();
                }else {
                    lpPubTriggerModel.content = content;
                }
                getLiveRoom().getToolBoxVM().requestQuestionPub(lpPubTriggerModel);
            });
        }

        //只有问题
        String nameAndContent = "提问者：" + lpQuestionPullListItems.get(0).from.name +
                "\n" + lpQuestionPullListItems.get(0).content;
        qaVH.qaText.setText(nameAndContent);

        if (lpQuestionPullListItems.size() == 1){
            Log.d(TAG, "无回答者");
        }else {
            //回复和取消发布交给item
            for (int i = 1; i < lpQuestionPullListItems.size(); i++){
                LPQuestionPullListItem lp = lpQuestionPullListItems.get(i);
                ViewGroup replyItem = (ViewGroup) LayoutInflater.from(getContext())
                                            .inflate(R.layout.item_toolbox_qa_reply_item,null);
                qaVH.replyManage.addView(replyItem);
                TextView textView = replyItem.findViewById(R.id.qa_reply_text);
                                String reply = "回复者:" + lp.from.name
                            + "\n"
                            + "内容：" + lp.content;
                textView.setText(reply);
            }
        }
    }

    public static class QaRecyclerCommonViewHolder extends RecyclerView.ViewHolder{

        TextView qaText;
        Button qaBtnDelete;
        Button qaBtnPublish;
        Button qaBtnReply;
        ViewGroup replyManage;
        EditText replyEt;

        public QaRecyclerCommonViewHolder(@NonNull View itemView) {
            super(itemView);
            qaText = itemView.findViewById(R.id.qa_text);
            qaBtnDelete = itemView.findViewById(R.id.qa_delete);
            qaBtnPublish = itemView.findViewById(R.id.qa_publish);
            qaBtnReply = itemView.findViewById(R.id.qa_reply_teacher);
            replyManage = itemView.findViewById(R.id.qa_manage_reply);
            replyEt = itemView.findViewById(R.id.qa_reply_teacher_et);
        }
    }
}
