package com.baijiayun.bjhl_liveplayer.fragment;

import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.os.Bundle;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AlertDialog;
import androidx.fragment.app.DialogFragment;

import com.baijiayun.livecore.models.imodels.IMessageModel;

public class OperateMessageFragment extends DialogFragment {

    String[] operations = new String[]{"撤回", "置顶", "翻译", "私聊"};
    MessageOperationListener messageOperationListener;
    IMessageModel messageModel;

    @Override
    public void onAttach(Context context) {
        messageOperationListener = (MessageOperationListener) context;
        super.onAttach(context);
    }

    public OperateMessageFragment() {

    }

    public OperateMessageFragment(IMessageModel messageModel) {
        this.messageModel = messageModel;
    }



    @NonNull
    @Override
    public Dialog onCreateDialog(Bundle savedInstanceState) {
        AlertDialog.Builder builder = new AlertDialog.Builder(getActivity());
        builder.setItems(operations, new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialogInterface, int i) {
                switch (i) {
                    case 0:
                        messageOperationListener.revokeMessage(messageModel);
                        break;
                    case 1:
                        messageOperationListener.stickMessage(messageModel);
                        break;
                    case 2:
                        messageOperationListener.translateMessage(messageModel);
                        break;
                    case 3:
                        messageOperationListener.sendMessageToUser(messageModel);
                        break;
                    default:
                        break;
                }
            }
        });
        return builder.create();
    }

    public interface MessageOperationListener {
        public void revokeMessage(IMessageModel messageModel);

        public void stickMessage(IMessageModel messageModel);

        public void translateMessage(IMessageModel messageModel);

        public void sendMessageToUser(IMessageModel messageModel);
    }
}
