package com.baijiayun.bjhl_liveplayer.fragment;

import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.os.Bundle;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.app.AlertDialog;
import androidx.fragment.app.DialogFragment;

import com.baijiayun.livecore.models.imodels.IMediaModel;
import com.baijiayun.livecore.wrapper.LPPlayer;

public class OperateVideoFragment extends DialogFragment {

    private String[] operations = new String[]{"打开视频","关闭视频","打开音频","关闭音频","拉大流","拉小流"};
    IMediaModel iMediaModel;

    public OperateVideoFragment(IMediaModel iMediaModel) {
        this.iMediaModel = iMediaModel;
    }

    public OperateVideoFragment() {

    }

    VideoOperationListener videoOperationListener;




    @Override
    public void onAttach(Context context) {
        super.onAttach(context);
        videoOperationListener = (VideoOperationListener) context;
    }

    @NonNull
    @Override
    public Dialog onCreateDialog(@Nullable Bundle savedInstanceState) {
        AlertDialog.Builder builder = new AlertDialog.Builder(getActivity());
        builder.setItems(operations, new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                switch (which){
                    case 0:
                        videoOperationListener.openVideo(iMediaModel);
                        break;
                    case 1:
                        videoOperationListener.closeVideo(iMediaModel);
                        break;
                    case 2:
                        videoOperationListener.openAudio(iMediaModel);
                        break;
                    case 3:
                        videoOperationListener.closeAudio(iMediaModel);
                        break;
                    case 4:
                        videoOperationListener.pullHighVideoStream(iMediaModel);
                        break;
                    case 5:
                        videoOperationListener.pullLowVideoStream(iMediaModel);
                        break;
                    default:
                        break;
                }
            }
        });
        return builder.create();
    }

    public interface VideoOperationListener{
        void openVideo(IMediaModel iMediaModel);
        void closeVideo(IMediaModel iMediaModel);
        void openAudio(IMediaModel iMediaModel);
        void closeAudio(IMediaModel iMediaModel);
        void pullHighVideoStream(IMediaModel iMediaModel);
        void pullLowVideoStream(IMediaModel iMediaModel);
    }
}
