package com.baijiayun.bjhl_liveplayer.utils;

import android.Manifest;
import android.app.Activity;
import android.content.Context;
import android.content.pm.PackageManager;

import androidx.core.app.ActivityCompat;
import androidx.core.content.ContextCompat;

public class Utils {
    public static final int REQUEST_CODE_PERMISSION_CAMERA = 1;
    public static final int REQUEST_CODE_PERMISSION_MIC = 2;
    public static final int REQUEST_CODE_PERMISSION_READ_EXTERNAL_STORAGE = 3;

    private Utils() {
    }

    public static boolean checkCameraPermission(Context context) {
        if (!(context instanceof Activity)) {
            return false;
        }
        if (PackageManager.PERMISSION_GRANTED == ContextCompat
                .checkSelfPermission(context, Manifest.permission.CAMERA)) {
            return true;
        } else {
            ActivityCompat.requestPermissions((Activity) context,
                    new String[]{Manifest.permission.CAMERA}, REQUEST_CODE_PERMISSION_CAMERA);
        }
        return false;
    }


    public static boolean checkMicPermission(Context context) {
        if (!(context instanceof Activity)) {
            return false;
        }
        if (PackageManager.PERMISSION_GRANTED == ContextCompat
                .checkSelfPermission(context, Manifest.permission.RECORD_AUDIO)) {
            return true;
        } else {
            ActivityCompat.requestPermissions((Activity) context,
                    new String[]{Manifest.permission.RECORD_AUDIO}, REQUEST_CODE_PERMISSION_MIC);
        }
        return false;
    }

    public static boolean checkFilePermission(Context context){
        if (!(context instanceof Activity)) {
            return false;
        }
        if (PackageManager.PERMISSION_GRANTED == ContextCompat
                .checkSelfPermission(context, Manifest.permission.READ_EXTERNAL_STORAGE)) {
            return true;
        } else {
            ActivityCompat.requestPermissions((Activity) context,
                    new String[]{Manifest.permission.READ_EXTERNAL_STORAGE}, REQUEST_CODE_PERMISSION_READ_EXTERNAL_STORAGE);
        }
        return false;
    }

    public static String convertTypeToString(int type){
        String conflict_message = "";

        switch (type) {
            case 0:
                conflict_message = "PC网页";
                break;
            case 1:
                conflict_message = "PC客户端";
                break;
            case 2:
                conflict_message = "M站";
                break;
            case 3:
                conflict_message = "IOS客户端";
                break;
            case 4:
                conflict_message = "Android客户端";
                break;
            case 5:
                conflict_message = "mac直播助手";
                break;
            default:
                break;
        }
        return conflict_message;
    }
}
